%function ROC = ROCconstr(classifierHandle,data)
function ROC = ROCconstr(classifierOutput,class)

%output: ROC.sensitivity
%       ROC.specificity
%       ROC.thresholds

%input: classifierOutput
%       class - vector of zeros and ones

numSamples = length(class);
numPosSamples = sum(class);
numNegSamples = numSamples-numPosSamples;

%output = classifierHandle(data.samples);
[outputSort order] = sort(classifierOutput);
classSort = class(order);

TN = 0; TP = numPosSamples; FN = 0; FP = numNegSamples;
ROC = [];
for i = 1:numSamples
    if classSort(i)
        FN = FN+1;
        TP = TP-1;
    else
        TN = TN+1;
        FP = FP-1;
    end

    ROC.sensitivity(i) = TP/(TP+FN);
    ROC.specificity(i) = TN/(TN+FP);
    ROC.thresholds(i) = outputSort(i);
end